/*

GrowingRoot simulates the regulation of root growth and developmental 
zonation by the interactions between phytohormone auxin, cytokinin mediated ARR1 and AR12, and the PLETHORA transcription factors
that together self organize control over meristem size in a simplified, two dimensional model of the Arabidopsis root.

Copyright 2017-2020, Jacob Pieter Rutten and Kirsten ten Tusscher


GrowingRoot is distributed under the terms of the GNU General Public 
License.


GrowingRoot is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GrowingRoot is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GrowingRoot.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef AuxinConfigHeader
#define AuxinConfigHeader



using namespace std;

//#define AUXINAPPLICATION
#define AUX1INEPI
//#define HCJBASEAUXDEGR

//auxine parameters
const double DauxC=600;
const double DauxW=40.;
const double eff=1;//0.01;//1.;
const double inAux=0.;
const double dAux=0.000058;
const double pAux=0.003;
const double pPUMP=0.2;
const double auxinflux = 0.8;
const double meristemfactor = 1;
#ifdef AUX1INEPI
const double inf=2.5;//10;
#else
const double inf=10;
#endif


#define ARFDIMERIZE
//Km is approximately: (ass/diss)*(pI/dITIR1)
const double ass=0.01;
const double diss=0.001;
const double pI=0.01;
const double dIbasal=0.0002; 
const double dITIR1=0.000825;
const double ARFtotal=100;

#define ARFLATCONTROL //ARF only have limited ability to turn on Plehtora in the LRC.
#ifdef ARFLATCONTROL
const double LRCARFfac= 0.7;
const double fullarfdistance = 12;
const double arfreductiondistance=43;
#endif

#endif
