/*

GrowingRoot simulates the regulation of root growth and developmental 
zonation by the interactions between phytohormone auxin, cytokinin mediated ARR1 and AR12, and the PLETHORA transcription factors
that together self organize control over meristem size in a simplified, two dimensional model of the Arabidopsis root.

Copyright 2017-2020, Jacob Pieter Rutten and Kirsten ten Tusscher


GrowingRoot is distributed under the terms of the GNU General Public 
License.


GrowingRoot is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GrowingRoot is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GrowingRoot.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef GeneralHeader
#define GeneralHeader

using namespace std;


#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <png.h>
#include "dSFMT.h"


extern char dirname[10000];
extern double phase;
extern int idlist[3000];
extern int idcounter;
extern int memid;
extern int counter2;
extern int maxmzheight;
extern int rightsize;
extern int leftsize;
extern int totalrootcellnrL;
extern int totalrootcellnrR;


extern dsfmt_t dsfmt;
inline double uniform() { return dsfmt_genrand_close_open(&dsfmt); }


#endif
