#include "Static.hh"
#include "Parameters.hh"
  
void InitPlant()
{
  SetUpTissueLayout();
  NumberCells();
  FindCellCorners();
  FindCellSizes();
  SetUpMembraneTypes();
  //SetUpPrePattern();
  InitConditions();
  UpdateMembraneProteinsAndFluxes(0);
  
}

void WritePlantToFile(int time)
{
  FILE *f;
  int i,j,q;
  char fname[800];
  sprintf(fname,"%s/DumpPlantStateAt%.10d",dirname,time);
  f=fopen(fname,"w");

  
  //tissue architecture and cell numbering
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%i\t",Tc[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%i\t",Tct[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%i\t",Tmt[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%i\t",Cell[i][j]);
      fprintf(f,"\n");
    }
  
  //location of transporters
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%f\t",PinPrePat[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%f\t",Pin2PrePat[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%f\t",Aux1PrePat[i][j]);
      fprintf(f,"\n");
    }
	for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%f\t",Lax3PrePat[i][j]);
      fprintf(f,"\n");
    }
   
  //auxin levels
  for(i=0;i<n;i++)
    {
    for(j=0;j<m;j++){
	  fprintf(f,"%f\t",Caux1[i][j]);
    }
      fprintf(f,"\n");
    }
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",MeanCells[q]);
  fprintf(f,"\n");
  
  //gene expression levels
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",ARF[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",AA[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",BB[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",CC[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",DD[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Plt[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Yuc3[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",ARR1[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",ARR12[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",RGA[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Gibberellin[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",GA3Ox2[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Gibinvac[q]);
  fprintf(f,"\n");
  
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",divTF[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",elongTF[q]);
  fprintf(f,"\n");
    
  
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Gh317[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Pin[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Pin2[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Plts[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Aux1[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Lax3[q]);
  fprintf(f,"\n");
  
  
  //miscelleanous
  for(q=0;q<totcells;q++)
    fprintf(f,"%i\t",TimePrevGrowth[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%f\t",Diff[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%i\t",CellZonationState[q]);
  fprintf(f,"\n");
  for(q=0;q<totcells;q++)
    fprintf(f,"%i\t",CellsInOZ[q]);
  fprintf(f,"\n");
  
  //nr of cells
  fprintf(f,"%i\n",actcells);
  fclose(f);

}



void InitPlantFromFile(int startt)
{
  FILE *f;
  int i,j,q;
  char fname2[800];
  float temp;
  int temp2;

  sprintf(fname2,"%s/DumpPlantStateAt%.10d",dirname,startt);
  f=fopen(fname2,"r");

  //tissue architecture and cell numbering
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      fscanf(f,"%i ",&(Tc[i][j]));
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      fscanf(f,"%i ",&(Tct[i][j]));
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      fscanf(f,"%i ",&(Tmt[i][j]));
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      fscanf(f,"%i ",&(Cell[i][j]));

  //location of transporters
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%f ",&temp);
	PinPrePat[i][j]=temp;
      }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%f ",&temp);
	Pin2PrePat[i][j]=temp;
      }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%f ",&temp);
	Aux1PrePat[i][j]=temp;
      }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%f ",&temp);
	Lax3PrePat[i][j]=temp;
      }    

  //auxin levels
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%f ",&temp);
	Caux1[i][j]=temp;

      }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      MeanCells[q]=temp;
    }

  //gene expression levels
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      ARF[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      AA[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      BB[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      CC[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      DD[q]=temp;
    }

  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Plt[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Yuc3[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      ARR1[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      ARR12[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      RGA[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Gibberellin[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
     GA3Ox2[q]=temp;
    }    
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Gibinvac[q]=temp;
    }    
    
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      divTF[q]=temp;
    }
     for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      elongTF[q]=temp;
    }
    
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Gh317[q]=temp;
    }

  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Pin[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Pin2[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Plts[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Aux1[q]=temp;
    }
  for(q=0;q<totcells;q++)
	{
	  fscanf(f,"%f ",&temp);
	  Lax3[q]=temp;
	}


  //miscelleanous
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%i ",&TimePrevGrowth[q]);
    }
  for(q=0;q<totcells;q++)
    {
      fscanf(f,"%f ",&temp);
      Diff[q]=temp;
    }
  for(q=0;q<totcells;q++)
    {
	  fscanf(f,"%i ",&CellZonationState[q]);

    }
  for(q=0;q<totcells;q++)
    {
	  fscanf(f,"%i ",&CellsInOZ[q]);
    }
  
  //nr of cells
  fscanf(f,"%i",&actcells);
  fclose(f);

  FindCellCorners();

  FindCellSizes();
  UpdateMembraneProteinsAndFluxes(0);


}


void SetUpTissueLayout()
{
  int i,j,k,l,ii;
  /*****************************************************************/  
  
  //in Tc[n][m] 
  //0 = wall
  //1 = cell
  //2 = membrane
  //3 = non-tissue
  
  //in Tct[n][m] 
  //0 = no cell
  //1 = lateral root cap 1
  //2 = lateral root cap 2
  //3 = lateral root cap 3
  //4 = lateral root cap 4
  //5 = epi
  //6 = cort
  //7 = endo
  //8 = peri
  //9 = vasc 1
  //10 = vasc 2
  //11 = vasc 3
  //12 = QC
  //13 = columella 1
  //14 = columella 2
  //15 = columella 3
  //16 = columella 4
  //17 = columella 5
  //18 = columella initials

  /******************************************************************/

  //0: Initially put all to non-tissue, no cell
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	Tc[i][j]=3;
	Tct[i][j]=0;
      }

  //1: Now, set up where there is plant tissue and where not
  //Step a: generate straight part of tissue without root cap
  for(i=xm;i>=disttoepi ;i--)
    for(j=yLRC1;j<TOPJCELLS;j++)
      {
	ii=n-1-i;
	Tc[i][j]=1;//make all cell, walls and membranes done later
	Tc[ii][j]=1;
	Tct[i][j]=5;//make all epidermal, other types done later
	Tct[ii][j]=5;
      }
  //Step b: generate straigth part of tissue with root cap
  for(i=xm;i>=disttolrc;i--)
    for(j=yLRCstraight;j<=yLRC1;j++) 
      {
	ii=n-1-i;
	Tc[i][j]=1;
	Tc[ii][j]=1;
	Tct[i][j]=5;
	Tct[ii][j]=5;
      }

  //Step c: generate curved part of tissue with root cap
  //for this use parabola describing the outer boundary of
  //the outermost root cap layer LRC1
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yLRCstraight;j++) 
      {
 	ii=n-1-i;
	if(j>=(int)(aLRC1*abs(pow((i-xm),powLRC1))+bLRC1))
	  {
	    Tc[i][j]=1;//make all cell, walls and membranes done later
	    Tc[ii][j]=1;
	    Tct[i][j]=1;//make all lateral root cap type, other types done later
	    Tct[ii][j]=1;
	  }
      }
  /************************************************************/

  //2: Next, setup where is cell wall and where are different cell types
  int temp;
  double iii,jjj;
  int I;

  //Step a: in straight part of tissue without root cap
  //vertical walls & celltypes
  for(j=yLRC1;j<TOPJCELLS;j++)
    {
      //set leftmost cell wall
      i=disttoepi;
      //set rightmost cell wall
      ii=n-1-i;
      Tc[i][j]=0;
      Tc[ii][j]=0;

      //start in the middle
      i=xm;
      //set middlemost wall
      Tc[i][j]=0;
      //go over the total nr of cells of epi, cort, endo, peri and vasc type
      for(k=0;k<nrepi+nrcort+nrendo+nrperi+nrvasc;k++)
	{
	  if(k<nrvasc)//cell of vasc type
	    {
	      //subdivide later 9-10-11
	      for(I=i;I>=i-(sizevasc+1);I--)//go over cell, inside out, assign type
		{
		  Tct[I][j]=9;
		  Tct[n-1-I][j]=9;
		}
	      //for assigning walls in between cells
	      i-=sizevasc+1;
	    }
	  else if(k<nrvasc+nrperi)
	    {
	      for(I=i;I>=i-(sizeperi+1);I--)
		{
		  Tct[I][j]=8;
		  Tct[n-1-I][j]=8;
		}
	      i-=sizeperi+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo)
	    {
	      for(I=i;I>=i-(sizeendo+1);I--)
		{
		  Tct[I][j]=7;
		  Tct[n-1-I][j]=7;
		}
	      i-=sizeendo+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort)
	    {
	      for(I=i;I>=i-(sizecort+1);I--)
		{
		  Tct[I][j]=6;
		  Tct[n-1-I][j]=6;
		}
	      i-=sizecort+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort+nrepi)
	    i-=sizeepi+1;
	  
	  Tc[i][j]=0;
	  ii=n-1-i;
	  Tc[ii][j]=0;
	}
    }
  //Step b: straight part of tissue with root cap
  //walls and celltypes
  for(j=yLRCstraight;j<=yLRC1;j++) 
    {
      //similar to above but with rootcap

  
      //set leftmost cell wall
      i=disttolrc;
      //set rightmost cell wall
      ii=n-1-i;
      Tc[i][j]=0;
      Tc[ii][j]=0;
     

      //middlemost wall
      i=xm;
      Tc[i][j]=0;

     
      //the presence of the lrc is in the +1
      for(k=0;k<nrepi+nrcort+nrendo+nrperi+nrvasc+1;k++)
	{
	  if(k<nrvasc)
	    {
	      //subdivide later 9-10-11
	      for(I=i;I>=i-(sizevasc+1);I--)//!
		{
		  Tct[I][j]=9;
		  Tct[n-1-I][j]=9;
		}
	      i-=sizevasc+1; //!
	    }
	  else if(k<nrvasc+nrperi)
	    {
	      for(I=i;I>=i-(sizeperi+1);I--)//!
		{
		  Tct[I][j]=8;
		  Tct[n-1-I][j]=8;
		}
	      i-=sizeperi+1; 
	    }
	  else if(k<nrvasc+nrperi+nrendo)
	    {
	      for(I=i;I>=i-(sizeendo+1);I--)//!
		{
		  Tct[I][j]=7;
		  Tct[n-1-I][j]=7;
		}
	      i-=sizeendo+1; 
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort)
	    {
	      for(I=i;I>=i-(sizecort+1);I--)//!
		{
		  Tct[I][j]=6;
		  Tct[n-1-I][j]=6;
		}
	      i-=sizecort+1; 
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort+nrepi)
	    i-=sizeepi+1;//!
	  else if(k<nrvasc+nrperi+nrendo+nrcort+nrepi+1)//!
	    {
	      //lrc1
	      for(I=i;I>=i-(sizetoplrc);I--)
		{
		  Tct[I][j]=1;
		  Tct[n-1-I][j]=1;
		}
	      i-=sizetoplrc; 
	    }
	  
	  Tc[i][j]=0;
	  ii=n-1-i;
	  Tc[ii][j]=0;
	}
    }

  //Step c: in curved part of tissue with root cap
  //semi-vertical lines (parabola) & celltypes
  //first walls
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yLRCstraight;j++) 
      {
	ii=n-1-i;
	if(Tc[i][j]!=3)
	  {
	    if(j==(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC) ||
	       i==n-1-(int)(pow(((j-bVASC)/aVASC),(1.0/powVASC))+xm))//MAYBE NOT TILL END
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI) ||
		    i==n-1-(int)(pow(((j-bPERI)/aPERI),(1.0/powPERI))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO) ||
		    i==n-1-(int)(pow(((j-bENDO)/aENDO),(1.0/powENDO))+xm))
	      {
		if(j>(int)(arad3*i+brad3))//if(j>(int)(arad4*i+brad4))
		  {
		    Tc[i][j]=0;
		    Tc[ii][j]=0;
		  }
	      }
	    else if(j==(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT) ||
		    i==n-1-(int)(pow(((j-bCORT)/aCORT),(1.0/powCORT))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI)||
		    i==n-1-(int)(pow(((j-bEPI)/aEPI),(1.0/powEPI))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j<yLRC4 && (j==(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4) ||
				i==n-1-(int)(pow(((j-bLRC4)/aLRC4),(1.0/powLRC4))+xm)) )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j<yLRC3 && (j==(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3) ||
				i==n-1-(int)(pow(((j-bLRC3)/aLRC3),(1.0/powLRC3))+xm)) )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j<yLRC2 && (j==(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2) ||
				i==n-1-(int)(pow(((j-bLRC2)/aLRC2),(1.0/powLRC2))+xm)) )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aLRC1*abs(pow((i-xm),powLRC1))+bLRC1) ||
		    i==n-1-(int)(pow(((j-bLRC1)/aLRC1),(1.0/powLRC1))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	  }
      }
  //then celltypes
  for(i=xm;i>=0;i--)
    for(j=0;j<yLRCstraight;j++) //!j=0;j<yLRC1-18*M1-2;j++
      {
	if(Tc[i][j]!=3)
	  {
	    ii=n-1-i;
	    //parabola like curves

	    //met de power 5 gaat er nog wat mis met celltypes
	    //opgelost met i>60, niet echt mooi
	    	
	   
	    //subdivide later 9-10-11
	    if(i>(60/xstep) && j>=(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC)) //!60
	      {
		Tct[i][j]=9;
		Tct[ii][j]=9;
	      }
	    else if(i>(60/xstep) && j>=(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI))
	      {
		Tct[i][j]=8;
		Tct[ii][j]=8;
	      }
	    else if(j>=(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO))
	      {
		Tct[i][j]=7;
		Tct[ii][j]=7;
	      }
	    else if(j>=(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT))
	      {
		Tct[i][j]=6;
		Tct[ii][j]=6;
	      }
	    else if(j>=(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI) )
	      {
		Tct[i][j]=5;
		Tct[ii][j]=5;
	      }
	    else if(j<(int)(arad2*i+brad2) && j>=(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4))
	      {
		Tct[i][j]=4;
		Tct[ii][j]=4;
	      }
	    else if(j<yLRC3 && j>=(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3))
	      {
		Tct[i][j]=3;
		Tct[ii][j]=3;
	      }
	    else if(j<yLRC2 && j>=(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2))
	      {
		Tct[i][j]=2;
		Tct[ii][j]=2;
	      }
	  }
      }
  //some more celltypes
  //QC and columella
  for(i=xm;i>=0;i--)
     for(j=yzero;j<yLRCstraight;j++)
       {
	 ii=n-1-i;
	 if(Tc[i][j]!=3)
	   {
	     //different collumella layers
	     if(Tct[i][j]==1 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=13;
		 Tct[ii][j]=13;
	       }
	     else if(Tct[i][j]==2 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=14;
		 Tct[ii][j]=14;
	       }
	     else if(Tct[i][j]==3 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=15;
		 Tct[ii][j]=15;
	       }
	     else if(Tct[i][j]==4 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=16;
		 Tct[ii][j]=16;
	       }
	     else if(Tct[i][j]==5 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=17;
		 Tct[ii][j]=17;

		 //zou evt opgesplitst in laag 15 en laag 16 moeten worden
	       }
	    
	     //QC
	     if((Tct[i][j]==6 || Tct[i][j]==7) && j<(int)(arad4*i+brad4))//cortex -> QC
	       {
		 Tct[i][j]=12;
		 Tct[ii][j]=12;
	       }
	   }
       }
  //above yR vertical lines inside vasculature
  //reducing nr of vasc cells to prevent narrowness
   for(j=yR;j<=yLRCstraight;j++)
    {
      //middle wall aligned with rest of tissue
      i=xm;
      Tc[i][j]=0;      
      for(k=0;k<nrvasc-1;k++)//nr cell files in vasc -1, outer wall given by parabola
	{
	 
	  i-=sizevasc;
	  Tc[i][j]=0;
	  ii=n-1-i;
	  Tc[ii][j]=0;
	}
    }
  //below yR, so from yQC onward, inside peri parabola
  //vertical lines for vasculature, reducing nr of
  //vascular cell files to prevent to narrow cells
  for(j=yQC+HMZ+1;j<yR;j++)
    {
      i=xm;
      i-=sizevasc+1;
      Tc[i][j]=0;
      ii=n-1-i;
      Tc[ii][j]=0;
    }

  /******************************************************************/

  //straight part of tissue with and without root cap
  //horizontal walls, different cellsizes (heights) in different zones
  for(i=xm;i>=disttolrc;i--)
    {
      ii=n-1-i;

      //bottommost one, first one of straight part
      j= yLRCstraight; 
      if(Tc[i][j]!=3)
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	}

      //then 15 walls at equal distances 
      //generating equally sized MZ cell
      for(k=1;k<=nrcellsstraightMZ;k++ )//for(k=1;k<=15;k++ )
	{
	  j+=HMZ+1; 
	  if(Tc[i][j]!=3)
	    {
	      //larger cells in lrc
	    if( Tct[i][j]!=1 || k==2 || k==5 || k==10 || k==16)
	      //if( Tct[i][j]!=1 || k==2 || k==5 || k==10)
		{
		  Tc[i][j]=0;
		  Tc[ii][j]=0;
		}
	    }
	}
      //then a wall to top off LRC, resulting
      //in slightly higher last MZ cell
      j=yLRC1;
      if(Tc[i][j]!=3)
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	}


      //then gradually increasing cell sizes 
      //as we go through EZ and end in DZ
      //WE HAVE AN EXTRA MYSTERY CELL WALL???
      for(k=0;k<nrcellsEZ;k++)
	{
	/*	
	  if(k==1)
	    j+=24/xstep+1;
	  else if(k==2)
	    j+=26/xstep+1;
	  else if(k==3)
	    j+=30/xstep+1;
	  else if(k==4)
	    j+=36/xstep+1;
	  else if(k==5)
	    j+=44/xstep+1;
	  else if(k==6)
	    j+=54/xstep+1;
	  else if(k==7)
	    j+=66/xstep+1;
	  else if(k==8)
	    j+=80/xstep+1;
	  else
	    j+=108/xstep+1;
	    
      */
      j+=HEZ/2+1;
      if(j<TOPJCELLS && Tc[i][j]!=3)
	    {
	      Tc[i][j]=0;
	      Tc[ii][j]=0;
	    }
      }
    for(k=0;k<nrcellsDZ;k++)
	  {

      j+=HDZ+1;
      if(j<TOPJCELLS && Tc[i][j]!=3)
	    {
	    Tc[i][j]=0;
	    Tc[ii][j]=0;
	  }
	}  
    for(k=0;k<nrcellsHJ;k++)
	  {
      j+=HJZ+1;

      if(j<TOPJCELLS && Tc[i][j]!=3)
	    {
	    Tc[i][j]=0;
	    Tc[ii][j]=0;
	  }
	}  

      /*
    j=TOPJCELLS-1;
      if(Tc[i][j]!=3)
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	}
	*/ 
      
    } 

  //in curved part of tissue with root cap
  //horizontal and radial lines
  //above yR horizontal lines
  for(i=xm;i>=0;i--)
    {
      ii=n-1-i;
      j=yR;
     
      //first horizontal line at j=yR
      if(Tc[i][j]!=3 )
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	}
      
      //horizontal walls for MZ cells above yR in curved part
      for(k=1;k<=5;k++ )//for(k=1;k<=3;k++ )
	{
	  
	  j+=HMZ+1;
	  if(Tc[i][j]!=3 )
	    {
	      if(Tct[i][j]>2 || (k==2 || k==5))//k%2==0)//(k==1 || k%3==0))//larger cells in lrc
		{
		  Tc[i][j]=0;
		  Tc[ii][j]=0;
		}
	    }
	}
    }

  //below yR, so from yQC onward, inside peri parabola
  //horizontal cell walls
  for(i=xm;i>=0;i--)
    {
      ii=n-1-i;
      j=yQC;

      for(k=1;k<=5;k++ )//for(k=1;k<=3;k++ )
	{
	  j+=HMZ+1;
	  if(Tc[i][j]!=3 && (Tct[i][j]>=8 && Tct[i][j]<=11))  
	    {
	      Tc[i][j]=0;
	      Tc[ii][j]=0;
	    }
	}
    }

 
  //below yR, inside LRC1 parabola
  //radial lines and vertical line in middle
  for(i=xm;i>=0;i--)
    for(j=yzero;j<yR;j++)
      {
	ii=n-1-i;
	
	if(j>yQC && j<yQC+HMZ+1)
	  {
	    if(i==(xm-(6/xstep)))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	  }
	
	if(i==xm)
	  {
	    Tc[i][j]=0;
	    Tc[ii][j]=0;
	  }
	else if(j>=(int)(aLRC1*abs(pow((i-xm),powLRC1))+bLRC1))
	  {
	    if((j==(int)(arad1*i+brad1) || i==(int)((j-brad1)/arad1)) && Tct[i][j]<8) 
	      {
	      if(j<(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO)){
		    Tc[i][j]=0;
		    Tc[ii][j]=0;
		  }
	    }
	    else if((j==(int)(arad2*i+brad2) || i==(int)((j-brad2)/arad2)) && Tct[i][j]<8 )	     
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    
	    else if((j==(int)(arad3*i+brad3) || i==(int)((j-brad3)/arad3)) && Tct[i][j]<8 )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if((j==(int)(arad4*i+brad4) || i==(int)((j-brad4)/arad4)) && (Tct[i][j]<8 || Tct[i][j]>11))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	   
	    }
      }
  //New: ensure continuity in walls
  //diffusion is only with neighbours directly above, below, left or right
  //if a wall has points wich are only connected to other wall points via
  //"diagonal neighbours" (below and left eg) there is no diffusion between
  //these wall points and hence there is discontinuity
  for(i=xm;i>0;i--){
    for(j=0;j<m;j++){
	ii=n-1-i;
	if(Tc[i][j]==0)//wall
	  {
	    //no direct upper down or left right neighbours also wall
	    if(!(Tc[i+1][j]==0 || Tc[i-1][j]==0 || Tc[i][j+1]==0 || Tc[i][j-1]==0))
	      {
		if(Tc[i+1][j+1]==0)
		  {
		    Tc[i+1][j]=0;
		    Tct[i+1][j]=0;
		    Tc[ii-1][j]=0;
		    Tct[ii-1][j]=0;
		  }
		else if(Tc[i+1][j-1]==0)
		  {
		    Tc[i+1][j]=0;
		    Tct[i+1][j]=0;
		    Tc[ii-1][j]=0;
		    Tct[ii-1][j]=0;
		  }
		else if(Tc[i-1][j+1]==0)
		  {
		    Tc[i-1][j]=0;
		    Tct[i-1][j]=0;
		    Tc[ii+1][j]=0;
		    Tct[ii+1][j]=0;
		  }
		else if(Tc[i-1][j-1]==0)
		  {
		    Tc[i-1][j]=0;
		    Tct[i-1][j]=0;
		    Tc[ii+1][j]=0;
		    Tct[ii+1][j]=0;
		  }
	      }
	  }
      }
  }
  
  /************************************************************/
  //next setup membranes based on cell walls
  for(i=0;i<n;i++)
    for(j=yzero;j<TOPJCELLS;j++)
      {
	if(Tc[i][j]==1)//cell
	  {
	    if(Tc[i+1][j]==0 || Tc[i-1][j]==0 || Tc[i][j+1]==0 || Tc[i][j-1]==0)//nb is wall
	      Tc[i][j]=2; //membrane
	  }
      } 
  
  
  for(i=0;i<n;i++)
    for(j=yzero;j<TOPJCELLS;j++)
      {
	if(Tc[i][j]==0)//cell wall
	  Tct[i][j]=20;//to get different colour there
      }
 
  /***********************************************************/

  //still need to subdivide vasc into 9 -10 -11
  int wallcounter2;
  for(j=yzero;j<TOPJCELLS;j++)
    {
      wallcounter2=0;
      for(i=xm;i>=0;i--)
	{
	  ii=n-1-i;
	  while(Tc[i][j]==0)
	    {
	      i--;
	      ii=n-1-i;
	    }
	  if(Tct[i][j]<9)
	    {
	      i=-(100/xstep);//!//no longer vasculature so end routine
	    }
	  else
	    {
	      while(Tct[i][j]==9)
		{
		  if(wallcounter2==0)//first cell files from middle out
		    {
		      Tct[i][j]=11;
		      Tct[ii][j]=11;
		    }
		  else if(wallcounter2==1)//second cell files from middle out
		    {
		      Tct[i][j]=10;
		      Tct[ii][j]=10;
		    }
		  else if(wallcounter2==2)
		    ;
		  i--;
		  ii=n-1-i;
		}
	      wallcounter2++;
	    }
	}
    }
  /*
  for(i=xm;i>=disttolrc;i--)
    for(j=yzero;j<TOPJCELLS;j++)
      {
	ii=n-1-i;
	if(Tct[i][j]!=Tct[ii][j])
	  {
	    printf("location %i,%i and %i,%i not identical\n",i,j,ii,j);
	    exit(1);
	  }
      }
  printf("initial cell types fully symmetric\n");
  */
}

void SetUpMembraneTypes()
{
  int i,ii,j,jj,q,iii,jjj;

  //bepaal membrane orientatie: 1: top, 2: bottom, 3: in, 4:out
  //op basis van waar is membraan Tc[i][j]==2, wat voor celltype is het
  //Tct[i][j]=??? en wat is de orientatie van de membraan en dus nearby
  //cell wall Twv[i][j]=???

  for(i=0;i<n;i++)
    for(j=yzero;j<TOPJCELLS;j++)
      {
	if(Tc[i][j]==2)
	  Tmt[i][j]=10;//dummy orientation if a membrane
	else
	  Tmt[i][j]=0;//no orientation if not a membrane
      }
  
  
  //straight part of root + part of rootcap that is more or less straight
  for(i=xm;i>=0;i--)
     for(j=yLRCstraight-1;j<=yEND;j++)//CHANGED!!!
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    if(j==CellMaxJ[Cell[i][j]])//top
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    else if(j==CellMinJ[Cell[i][j]])//bottom
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if(Tc[i+1][j]==0)//right
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if(Tc[i-1][j]==0)//left
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	  }
      }
  //end of straight part of root + part of rootcap that is more or less straight
  
  
  //curved part of root, only vasculature so top and bottom straight
  for(i=xm;i>=0;i--)
    for(j=yQC;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    if(Tct[i][j]==8 || Tct[i][j]==9 || Tct[i][j]==10 || Tct[i][j]==11)
	      {
		if(j==CellMaxJ[Cell[i][j]])//top
		  {
		    Tmt[i][j]=1;
		    Tmt[ii][j]=1;
		  }
		else if(j==CellMinJ[Cell[i][j]])//bottom
		  {
		    Tmt[i][j]=2;
		    Tmt[ii][j]=2;
		  }
		else if(Tc[i+1][j]==0)//right
		  {
		    Tmt[i][j]=3;
		    Tmt[ii][j]=3;
		  }
		else if(Tc[i-1][j]==0)//left
		  {
		    Tmt[i][j]=4;
		    Tmt[ii][j]=4;
		  }
	      }
	  }
      }
  //end of curved part of root, only vasculature


  //CHANGES FROM HERE ON!!!!

  //curved part of root
  //upward and downward oriented membranes relative to radial lines
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    if((j-1)==(int)(arad1*i+brad1) || (i+1)==(int)((j-brad1)/arad1))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad1*i+brad1)|| (i-1)==(int)((j-brad1)/arad1))
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if((j-1)==(int)(arad2*i+brad2)|| (i+1)==(int)((j-brad2)/arad2))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad2*i+brad2)|| (i-1)==(int)((j-brad2)/arad2)  //ADDING IN KIRSTEN LINE 1126 below here!!
	      || (j+2)==(int)(arad2*i+brad2)|| (i-1)==(int)((j-brad2)/arad2))
	      {
		//this wall tends to get steep, and therefore the new repair
		//algorithm to ensure continuity of walls kicks in
		//as a consequence distance with the equation for this line
		//is a bit enlarged because the wall has been blown up a bit
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if((j-1)==(int)(arad3*i+brad3)|| (i+1)==(int)((j-brad3)/arad3))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad3*i+brad3)|| (i-1)==(int)((j-brad3)/arad3))
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if((j-1)==(int)(arad4*i+brad4)|| (i+1)==(int)((j-brad4)/arad4))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad4*i+brad4)|| (i-1)==(int)((j-brad4)/arad4))
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if(i==xm-1)
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    if(i==xm+1)
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	  }
      }


  //repair missing parts top and down membranes
  int nb_1;
  int nb_2;
  int temp[n][m];
  int th=2;
  for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      temp[i][j]=Tmt[i][j];
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//type not identified;
	  {
	    nb_1=0;
	    nb_2=0;
	    for(iii=i-1;iii<=i+1;iii++)
	      for(jjj=j-1;jjj<=j+1;jjj++)
		{
		  
		  if(Cell[i][j]==Cell[iii][jjj] && Tmt[iii][jjj]==1)
		    nb_1++;		  
		  else if(Cell[i][j]==Cell[iii][jjj] && Tmt[iii][jjj]==2)
		    nb_2++;
		}
	    if(nb_1>=th)
	      {
		temp[i][j]=1;
		temp[ii][j]=1;
	      }
	    else if(nb_2>=th)
	      {
		temp[i][j]=2;
		temp[ii][j]=2;
	      }
	  }
      }
  for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      Tmt[i][j]=temp[i][j];


  //curved part of root
  //inward and outward oriented membranes relative to parabola
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    //outward pointing membranes
	    if(Tc[i-2][j-2]==3)//outmost cell membrane
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bLRC2)/aLRC2),(1.0/powLRC2))+xm) ||
		    (j-1)==(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if(j<yLRC3-(1/xstep) &&
			((i-1)==n-1-(int)(pow(((j-bLRC3)/aLRC3),(1.0/powLRC3))+xm) ||
		    (j-1)==(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3))) //!j<yLRC3-1
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if(j<yLRC4-(1/xstep) && 
		    ((i-1)==n-1-(int)(pow(((j-bLRC4)/aLRC4),(1.0/powLRC4))+xm) ||
		     (j-1)==(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4))) //!j<yLRC4-1
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bEPI)/aEPI),(1.0/powEPI))+xm) ||
		    (j-1)==(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bCORT)/aCORT),(1.0/powCORT))+xm) ||
		    (j-1)==(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bENDO)/aENDO),(1.0/powENDO))+xm) ||
		    (j-1)==(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO))
	      {
		if(j>(int)(arad4*i+brad4))
		  {
		    Tmt[i][j]=4;
		    Tmt[ii][j]=4;
		  }
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bPERI)/aPERI),(1.0/powPERI))+xm) ||
		    (j-1)==(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bVASC)/aVASC),(1.0/powVASC))+xm) ||
		    (j-1)==(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    
	    
	    //inward pointing membranes
	    if((i+1)==n-1-(int)(pow(((j-bLRC2)/aLRC2),(1.0/powLRC2))+xm) ||
	       (j+1)==(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bLRC3)/aLRC3),(1.0/powLRC3))+xm) ||
	       (j+1)==(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if(j<yLRC4-(1/xstep) && 
		    ((i+1)==n-1-(int)(pow(((j-bLRC4)/aLRC4),(1.0/powLRC4))+xm) ||
		     (j+1)==(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4))) //!j<yLRC4-1
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bEPI)/aEPI),(1.0/powEPI))+xm) ||
	       (j+1)==(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bCORT)/aCORT),(1.0/powCORT))+xm) ||
	       (j+1)==(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bENDO)/aENDO),(1.0/powENDO))+xm) ||
	       (j+1)==(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO))
	      {
		if(j>(int)(arad4*i+brad4))
		  {
		    Tmt[i][j]=3;
		    Tmt[ii][j]=3;
		  }
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bPERI)/aPERI),(1.0/powPERI))+xm) ||
	       (j+1)==(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bVASC)/aVASC),(1.0/powVASC))+xm) ||
	       (j+1)==(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }	     
	  }
      }
  //repair missing parts in en outward membranes
  //note that this repair is boosted, threshold is lowered till 1
  //and procedure is applied multiple times
  int nb_3;
  int nb_4;
  int iter=10;
  for(int k=0;k<iter;k++)
    {
  for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      temp[i][j]=Tmt[i][j];
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//type not identified;
	  {
	    nb_3=0;
	    nb_4=0;
	    for(iii=i-1;iii<=i+1;iii++)
	      for(jjj=j-1;jjj<=j+1;jjj++)
		{
		  if(Cell[i][j]==Cell[iii][jjj] && Tmt[iii][jjj]==3)
		    nb_3++;
		  else if(Cell[i][j]==Cell[iii][jjj] && Tmt[iii][jjj]==4)
		    nb_4++;
		}
	    if(nb_3>=1)
	      {
		temp[i][j]=3;
		temp[ii][j]=3;
	      }
	    else if(nb_4>=1)
	      {
		temp[i][j]=4;
		temp[ii][j]=4;
	      }
	  }
      }
   for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      Tmt[i][j]=temp[i][j];
    }

  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(Tc[i][j]==0)//cell wall
	  Tct[i][j]=20;//to get different colour there
      }
 
  
  //check symmetry initial tissue layout
  for(j=0;j<m;j++)
    for(i=0;i<xm;i++)
      {
	ii=n-1-i;
	if(Tmt[i][j]!=Tmt[ii][j])//if(Tc[i][j]!=Tc[ii][j])
	  {
	    printf("something is wrong in tissue layout at %i %i and %i %i celltype is %i and %i\n",i,j,n-1-i,j,Tct[i][j],Tct[n-1-i][j]);
	  } 
      } 
  //printf("finished checking initial tissue layout\n");
  //exit(1); 
  
  
}


void NumberCells()
{
  int i,j;
  int q=0;

  //nummer de cellen
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Cell[i][j]=-1;

  int count=0;
  int nbs;
  int ii,jj;
  int dist;
  for(j=0;j<m;j++)
    for(i=0;i<n;i++)
	{
	  if(Tc[i][j]==2 || Tc[i][j]==1)//cell membrane or cytosol
	    { 
	      if(j>=yLRC1)
		{
		  if((Cell[i-1][j]==-1 && Cell[i][j-1]==-1)&&(Cell[i+1][j]==-1 && Cell[i][j+1]==-1))
		    {
		      Cell[i][j]=q;
		      //printf("location is %i %i; cell nr is %i\n",i,j,q);
		      q++;
		    }
		  else
		    {
		      if(Cell[i-1][j]!=-1)
			Cell[i][j]=Cell[i-1][j];
		      else if(Cell[i][j-1]!=-1)
			Cell[i][j]=Cell[i][j-1];
		      else if(Cell[i+1][j]!=-1)
			Cell[i][j]=Cell[i+1][j];
		      else if(Cell[i][j+1]!=-1)
			Cell[i][j]=Cell[i][j+1];
		    }
		}
	      else
		{
		  nbs=0;
		  dist=1;
		  for(ii=i-dist;ii<=i+dist;ii++)
		    for(jj=j-dist;jj<=j+dist;jj++)
		      {
			if(!((ii==i-1 && jj==j-1) || (ii==i+1 && jj==j-1)))
			  {
			    if(Cell[ii][jj]!=-1)
			      {
				Cell[i][j]=Cell[ii][jj];
				nbs++;
				count++;
				ii=i+1000;
				jj=j+1000;
			      }
			  }
		      }
		  jj=j-1;
		  ii=i;
		  while(ii<i+10 && Tc[ii][j]!=0)
		    {
		      if(Cell[ii][jj]!=-1)
			{
			  Cell[i][j]=Cell[ii][jj];
			  count++;
			  nbs++;
			  break;
			}
		      else
			ii++;
		    }

		  if(nbs==0)
		    {
		      Cell[i][j]=q;
		      q++;
		      count++;
		    }   
		}
	    }
	}

  actcells=q;
}

void FindCellCorners()
{
  int i,j,q;

  //find mini,maxi,minj,maxj,width,height of cells
  for(q=0;q<totcells;q++)
    {
      CellMinI[q]=10000;
      CellMinJ[q]=10000;
      CellMaxI[q]=0;
      CellMaxJ[q]=0;
      CellWidth[q]=0;
      CellHeight[q]=0;
    }
  for(i=0;i<n;i++){
    for(j=0;j<m;j++)
      {
	  q=Cell[i][j];
	if(q!=-1)
	  {
	    if(i<CellMinI[q])
	      CellMinI[q]=i;
	    if(i>CellMaxI[q]) // removed else because there is now a 1 pixel cell.
	      CellMaxI[q]=i;
	    if(j<CellMinJ[q])
	      CellMinJ[q]=j;
	    if(j>CellMaxJ[q])// removed else because there is now a 1 pixel cell.
	      CellMaxJ[q]=j;
	  }
      }
  }
  //non straigth cells? major and minor axis length instead?, centroid?
  for(q=0;q<actcells;q++)
    {
      CellWidth[q]=CellMaxI[q]-CellMinI[q]+1;
      CellHeight[q]=CellMaxJ[q]-CellMinJ[q]+1;
    }
}


void FindCellSizes()
{
  int i,j,q;
  
  //clean arrays
  for(q=0;q<totcells;q++)
    {
      CellSizes[q]=0;
      InvCellSizes[q]=0;
    }
  
  //sla de grootte op van alle cellen  
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(Cell[i][j]>=0)
	  CellSizes[Cell[i][j]]++;
	}
  
  for(q=0;q<actcells;q++)
    InvCellSizes[q]=1.0/(double)CellSizes[q];
}

void SetUpPrePattern()
{

  int q,i,j,ii;
  
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	PinPrePat[i][j]=0;
	Pin2PrePat[i][j]=0;
	Aux1PrePat[i][j]=0;
      }

#ifdef POLAR
  for(i=xm;i>=0;i--)
    for(j=0;j<m;j++)
      {
	int kk,ll;
    int mindist;
    int disttresh;
    int distance; 
	ii=n-1-i;
	q=Cell[i][j];
#ifdef APOLARMERISTEM
if(Tc[i][j]==2)//membrane
	  {
		if(Tct[i][j]<=4) //lateral root cap
	    {
			
			if(Tct[i][j]==1 && j> yLRCstraight) //lateral root cap
			 {
			if(Tmt[i][j]==1)//up
				{
				Pin2PrePat[i][j]=0.75;
				Pin2PrePat[ii][j]=0.75;
				}
			 else if(Tmt[i][j]==3)//inward membrane
					{
					 //if(Tct[i][j]==1)//CellMinJ[Cell[i][j]]> xxxxxx)//only for last few lateral root cap cells
					 //{
					  disttresh=(int)(0.2*(CellMaxJ[Cell[i][j]]-CellMinJ[Cell[i][j]]));
					  distance = 2*disttresh;
					  //printf("Disttresh is %i\n",disttresh);
					  //which part of membrane you want to do this for, make it dependent on size cell

					 for(kk=max(0,i-50);kk<=min(n-1,i+50);kk++) //min max to not go
						for(ll=max(0,CellMinJ[Cell[i][j]]);ll<=min(m-1,CellMaxJ[Cell[i][j]]);ll++)//outside the field
							 {
								if(Tmt[i][ll]==1 && ll>=CellMinJ[q])//upward membrane
								{
									   distance=abs(kk-1)+abs(ll-j);
									   //printf("distance is %i\n",distance);
										if(distance<=disttresh)
												{
													kk=10000;
													ll=10000;//to stop searching
												}
								}
							  if(distance<=disttresh)
							   {
									Pin2PrePat[i][j]=1;
									Pin2PrePat[ii][j]=1;
							   }
							  }
					  // }
					}
			}
			else
			{
				if(Tmt[i][j]==1)//up
				{
					Pin2PrePat[i][j]=0.5;
					Pin2PrePat[ii][j]=0.5;
				}
				else
			{
				if(Tmt[i][j]==1)//up
				{
					Pin2PrePat[i][j]=0.5;
					Pin2PrePat[ii][j]=0.5;
				}
				else if(Tmt[i][j]==3)//inward membrane
					{
					 //if(Tct[i][j]==1)//CellMinJ[Cell[i][j]]> xxxxxx)//only for last few lateral root cap cells
					 //{
					  disttresh=(int)(0.2*(CellMaxJ[Cell[i][j]]-CellMinJ[Cell[i][j]]));
					  distance = 2*disttresh;
					  //printf("Disttresh is %i\n",disttresh);
					  //which part of membrane you want to do this for, make it dependent on size cell

					 for(kk=max(0,i-50);kk<=min(n-1,i+50);kk++) //min max to not go
						for(ll=max(0,CellMinJ[Cell[i][j]]);ll<=min(m-1,CellMaxJ[Cell[i][j]]);ll++)//outside the field
							 {
								if(Tmt[i][ll]==1  && ll>=CellMinJ[q])//upward membrane
								{
									   distance=abs(kk-1)+abs(ll-j);
									   //printf("distance is %i\n",distance);
										if(distance<=disttresh)
												{
													kk=10000;
													ll=10000;//to stop searching
												}
								}
							  if(distance<=disttresh)
							   {
									Pin2PrePat[i][j]=0.1;
									Pin2PrePat[ii][j]=0.1;
							   }
							  }
					  // }
					}
			} 
			} 
		}
	   

	    else if(Tct[i][j]==5)//epidermis
	      {

			if(Tmt[i][j]==1)//up
			{
				Pin2PrePat[i][j]=1;
				Pin2PrePat[ii][j]=1;
			}
			else if(Tmt[i][j]==2)//down
			{
				if(CellZonationState[q]==0)
				  {
					  if(j<=(int)(arad1*i+brad1))
					  {
						Pin2PrePat[i][j]=0.7;
						Pin2PrePat[ii][j]=0.7;
					  } 
					  else
					  {
						Pin2PrePat[i][j]=0.25;
						Pin2PrePat[ii][j]=0.25;
					  } 
					}
			}
			else if(Tmt[i][j]==3)//in
	        {
				  if(CellZonationState[q]==0)
				  {
					if(j<=(int)(arad1*i+brad1))
					{
						Pin2PrePat[i][j]=0.5;
						Pin2PrePat[ii][j]=0.5;
					} 
					else
					{
					Pin2PrePat[i][j]=0.25;
					Pin2PrePat[ii][j]=0.25;
				    }
				 } 
				 else
				  {
					Pin2PrePat[i][j]=0.1;
					Pin2PrePat[ii][j]=0.1;
				  }
			 }
			else if(Tmt[i][j]==4)//out
	        {
		  if(j<yLRC1-8*HMZ)
				  {
					  if(CellZonationState[q]==0)
						{
						if(j<=(int)(arad1*i+brad1))
						{
							{
								Pin2PrePat[i][j]=0.5;
								Pin2PrePat[ii][j]=0.5;
							 } 
						}
						else
						{
							Pin2PrePat[i][j]=0.25;
							Pin2PrePat[ii][j]=0.25;
						 } 
					 }
					 else
					 {
						
						Pin2PrePat[i][j]=0.1;
						Pin2PrePat[ii][j]=0.1;
					}
				}
			 }
		  }
		else if(Tct[i][j]==6)//cortex
	      {
		
			if(Tmt[i][j]==1 && CellZonationState[q]>=60) //j>m/3.5) //j>YR)//up
			  {
		   
				PinPrePat[i][j]=1;
				PinPrePat[ii][j]=1;
			  }
			//else if(Tmt[i][j]==2 && CellZonationState[q]<=30) //j<m/4) //j<YR)//down
			else if(Tmt[i][j]==2)//down
			{
				if(CellZonationState[q]<=30)
					{
						PinPrePat[i][j]=1;
						PinPrePat[ii][j]=1;
					}
				  
			}
			else if(Tmt[i][j]==3)//in
	        {
				  if(CellZonationState[q]==0)
				  {
					if(j<=(int)(arad1*i+brad1))
					{
						PinPrePat[i][j]=0.5;
						PinPrePat[ii][j]=0.5;
					} 
					else
					{
					PinPrePat[i][j]=0.25;
					PinPrePat[ii][j]=0.25;
				    }
				 } 
				 else
				  {
					PinPrePat[i][j]=0.1;
					PinPrePat[ii][j]=0.1;
				  }
			 }
			else if(Tmt[i][j]==4)//out
	        {
		  if(j<yLRC1-8*HMZ)
				  {
					  if(CellZonationState[q]==0)
						{
						if(j<=(int)(arad1*i+brad1))
						{
							{
								PinPrePat[i][j]=0.5;
								PinPrePat[ii][j]=0.5;
							 } 
						}
						else
						{
							PinPrePat[i][j]=0.25;
							PinPrePat[ii][j]=0.25;
						 } 
					 }
					 else
					 {
						
						PinPrePat[i][j]=0.1;
						PinPrePat[ii][j]=0.1;
					}
				}
			 }
		  }
	    else if(Tct[i][j]==7)//endodermis
	      {
			if(Tmt[i][j]==2)//down
			  {
				PinPrePat[i][j]=1;
				PinPrePat[ii][j]=1;
			  }
			else if(Tmt[i][j]==1 && j<=(int)(arad1*i+brad1)) //Up
			{
				PinPrePat[i][j]=1;
				PinPrePat[ii][j]=1;
			}
			else if(Tmt[i][j]==3)//in
		    {
				  if(CellZonationState[q]==0)
				  {
					 if(CellZonationState[q]==0 && j<=(int)(arad1*i+brad1))
					  {
						PinPrePat[i][j]=0.7;
						PinPrePat[ii][j]=0.7;
					  } 
					  else
					  {  
						PinPrePat[i][j]=0.5;
						PinPrePat[ii][j]=0.5;
					  } 
				  }
				  else //if(CellZonationState==30)//PIN1 exp ends on MZ/EZ border
				  {
					PinPrePat[i][j]=0.35;
					PinPrePat[ii][j]=0.35;
				  }
			 }
			else if(Tmt[i][j]==4)//out
			{
			
				  if(CellZonationState[q]==0)
				  {
					  if(j<=(int)(arad1*i+brad1))
					  {
						PinPrePat[i][j]=0.7;
						PinPrePat[ii][j]=0.7;
					  } 
					  else
					  {  
						PinPrePat[i][j]=0.35;
						PinPrePat[ii][j]=0.35;
					  } 
				  }
				  else if(CellZonationState[q]==30 && j<yLRC1-8*HMZ)
				  {
					PinPrePat[i][j]=0.1;
					PinPrePat[ii][j]=0.1;
				  }
				  else
				  {
					PinPrePat[i][j]=0;
					PinPrePat[ii][j]=0;
				  }
			 }		
			}
	      
	    else if(Tct[i][j]==8)//pericycle
	      {
			if(j>(int)(arad3*i+brad3))
			  {
				if(Tmt[i][j]==2)//down
				  {
					PinPrePat[i][j]=1;
					PinPrePat[ii][j]=1;
				  }
				else if(Tmt[i][j]==3)//in
				{
					  if(CellZonationState[q]==0)
					  {
						  if(j<=(int)(arad1*i+brad1))
						  {
							PinPrePat[i][j]=0.7;
							PinPrePat[ii][j]=0.7;
						  } 
						  else
						  {  
							PinPrePat[i][j]=0.5;
							PinPrePat[ii][j]=0.5;
						  } 
					  }
					  else if(CellZonationState[q]==30) //PIN1 exp ends on MZ/EZ border
					  {
						PinPrePat[i][j]=0.35;
						PinPrePat[ii][j]=0.35;
					  }
					  else
					  {
						PinPrePat[i][j]=0.1;
						PinPrePat[ii][j]=0.1;
					  }
				 }
				
					  
			else if(Tmt[i][j]==4)//out
			{
			
				   if(CellZonationState[q]==0)
				  {
					  if(j<=(int)(arad1*i+brad1))
					  {
						PinPrePat[i][j]=0.7;
						PinPrePat[ii][j]=0.7;
					  } 
					  else
					  {  
						PinPrePat[i][j]=0.35;
						PinPrePat[ii][j]=0.35;
					  } 
				  }
				  else if(CellZonationState[q]==30 && j<yLRC1-7*HMZ)
				  {
					PinPrePat[i][j]=0.1;
					PinPrePat[ii][j]=0.1;
				  }
			 }		
			
		  } 
			else
			  {
				if(Tmt[i][j]==4 || Tmt[i][j]==3 || Tmt[i][j]==2 || Tmt[i][j]==1)//(down is defined as out here, due to circularity)
				  {
					PinPrePat[i][j]=1;
					PinPrePat[ii][j]=1;
				  }
			  }
			}
	    else if(Tct[i][j]==9 || Tct[i][j]==10 || Tct[i][j]==11)//vasculature
	      {
		    if(Tmt[i][j]==2)//down
				{ 
					if(CellZonationState[q]==0)
					  {
						  if(j<=(int)(arad1*i+brad1))
						  {
							PinPrePat[i][j]=0.75;
							PinPrePat[ii][j]=0.75;
						  } 
						  else 
						  {  
							PinPrePat[i][j]=1;
							PinPrePat[ii][j]=1;
						  } 
						}
					else
						 {  
							PinPrePat[i][j]=1;
							PinPrePat[ii][j]=1;
						  } 
					}
					
			else if(Tmt[i][j]==3)//inward membrane
				{
					 if(CellZonationState[q]==0)
					  {
						  if(j<=(int)(arad1*i+brad1))
						  {
							PinPrePat[i][j]=0.75;
							PinPrePat[ii][j]=0.75;
						  } 
						  else if(j<yR)
						  {  
							PinPrePat[i][j]=0.5;
							PinPrePat[ii][j]=0.5;
						  } 
						  else
						  {  
							PinPrePat[i][j]=0.3;
							PinPrePat[ii][j]=0.3;
						  } 
					  }
					else if(CellZonationState[q]==30)
					{
						PinPrePat[i][j]=0.2;
						PinPrePat[ii][j]=0.2;
					}
				}
			else if(Tmt[i][j]==4)//out 
			  {
				 
					 if(CellZonationState[q]==0)
					  {
						  if(j<=(int)(arad1*i+brad1))
						  {
							PinPrePat[i][j]=0.75;
							PinPrePat[ii][j]=0.75;
						  } 
						  else if(j<yR)
						  {  
							PinPrePat[i][j]=0.4;
							PinPrePat[ii][j]=0.4;
						  } 
						  else
						  {  
							PinPrePat[i][j]=0.2;
							PinPrePat[ii][j]=0.2;
						  } 
					  }
					else if(CellZonationState[q]==30)
					{
						PinPrePat[i][j]=0.1;
						PinPrePat[ii][j]=0.1;
					}
					else
					{
						PinPrePat[i][j]=0.1;
						PinPrePat[ii][j]=0.1;
					}
				}
			}
	     else if(Tct[i][j]==12)//QC
	      {
			if(Tmt[i][j]==4)//(down is defined as out here, due to circularity)
			  {
				PinPrePat[i][j]=1;
				PinPrePat[ii][j]=1;
			  }
	      }
	    else if(Tct[i][j]==13)//columella bottom layer
	      {
			if(Tmt[i][j]<4)
			  {
				PinPrePat[i][j]=0.5;
				PinPrePat[ii][j]=0.5;
			  }
	      }
	    else if(Tct[i][j]>13)//columella
	       {
				PinPrePat[i][j]=1;
				PinPrePat[ii][j]=1;
	       }
	   
	  }
#endif	  
	
#ifdef POLARMERISTEM
	if(Tc[i][j]==2)//membrane
	  {
	    if(Tct[i][j]<=4) //lateral root cap
	    {
			
			if(Tct[i][j]==1 && j>yLRCstraight) //lateral root cap
			 {
				if(Tmt[i][j]==1)//up
					{
					Pin2PrePat[i][j]=0.75;
					Pin2PrePat[ii][j]=0.75;
					}
				else if(Tmt[i][j]==3)//inward membrane
					{
					 //if(Tct[i][j]==1)//CellMinJ[Cell[i][j]]> xxxxxx)//only for last few lateral root cap cells
					 //{
					  disttresh=(int)(0.2*(CellMaxJ[Cell[i][j]]-CellMinJ[Cell[i][j]]));
					  distance = 2*disttresh;
					  //printf("Disttresh is %i\n",disttresh);
					  //which part of membrane you want to do this for, make it dependent on size cell

					 for(kk=max(0,i-50);kk<=min(n-1,i+50);kk++) //min max to not go
						for(ll=max(0,CellMinJ[Cell[i][j]]);ll<=min(m-1,CellMaxJ[Cell[i][j]]);ll++)//outside the field
							 {
								if(Tmt[i][ll]==1  && ll>=CellMinJ[q])//upward membrane
								{
									   distance=abs(kk-1)+abs(ll-j);
									   //printf("distance is %i\n",distance);
										if(distance<=disttresh)
												{
													kk=10000;
													ll=10000;//to stop searching
												}
								}
							  if(distance<=disttresh)
							   {
									Pin2PrePat[i][j]=1;
									Pin2PrePat[ii][j]=1;
							   }
							  }
					  // }
					}
			}
			else
			{
				if(Tmt[i][j]==1)//up
				{
					Pin2PrePat[i][j]=0.5;
					Pin2PrePat[ii][j]=0.5;
				}
			} 
		}
	    else if(Tct[i][j]==5)//epidermis
	      {

		if(Tmt[i][j]==1)//up
		  {
		    //if(Tc[i][j+2]!=3)
		      {
			Pin2PrePat[i][j]=1;
			Pin2PrePat[ii][j]=1;
		      }
		      /*else
		      {
			PinPrePat[i][j]=0.1;
			PinPrePat[ii][j]=0.1;
			}*/
		  }
		else if(Tmt[i][j]==3)//in
		  {
		    Pin2PrePat[i][j]=0.1;
		    Pin2PrePat[ii][j]=0.1;
		  }
	      }
	    else if(Tct[i][j]==6)//cortex
	      {
		
		if(Tmt[i][j]==1 && j>YR)//up
		  {
		    //if(Tc[i][j+2]!=3)
		      {
			Pin2PrePat[i][j]=1;
			Pin2PrePat[ii][j]=1;
		      }
		      /*else
		      {
			PinPrePat[i][j]=0.1;
			PinPrePat[ii][j]=0.1;
			}*/
		  }
		else if(Tmt[i][j]==2 && j<YR)//down
		  {
		    Pin2PrePat[i][j]=1;
		    Pin2PrePat[ii][j]=1;
		  }
		else if(Tmt[i][j]==3)//in
		  {
		    Pin2PrePat[i][j]=0.1;
		    Pin2PrePat[ii][j]=0.1;
		  }
	      }
	    else if(Tct[i][j]==7)//endodermis
	      {
		if(Tmt[i][j]==2)//down
		  {
		    Pin2PrePat[i][j]=1;
		    Pin2PrePat[ii][j]=1;
		  }
		else if(Tmt[i][j]==3)//in
		  {
		    Pin2PrePat[i][j]=0.35;
		    Pin2PrePat[ii][j]=0.35;
		  }
	      }
	    else if(Tct[i][j]==8)//pericycle
	      {
		if(j>(int)(arad4*i+brad4))
		  {
		    if(Tmt[i][j]==2)//down
		      {
			Pin2PrePat[i][j]=1;
			Pin2PrePat[ii][j]=1;
		      }
		   else if(Tmt[i][j]==3)//in, EXTRA????!!!
		      {
			Pin2PrePat[i][j]=0.1;
			Pin2PrePat[ii][j]=0.1;
		      }
		  }
		else
		  {
		    if(Tmt[i][j]==4)//(down is defined as out here, due to circularity)
		      {
			Pin2PrePat[i][j]=1;
			Pin2PrePat[ii][j]=1;
		      }
		  }
	      }
	    else if(Tct[i][j]==9 || Tct[i][j]==10 || Tct[i][j]==11)//vasculature
	      {
		if(Tmt[i][j]==2)//down
		  {
		   
		    Pin2PrePat[i][j]=1;
		    Pin2PrePat[ii][j]=1;
		  }
		else if(Tmt[i][j]==4)//out //EXTRA, TO ENHANCE AUXIN IN PERICYCLE AND PROTOXYLEM
		  {
		    Pin2PrePat[i][j]=0.1;
		    Pin2PrePat[ii][j]=0.1;
		  }
	      }
	    else if(Tct[i][j]==12)//QC
	      {
		if(Tmt[i][j]==4)//(down is defined as out here, due to circularity)
		  {
		    Pin2PrePat[i][j]=1;
		    Pin2PrePat[ii][j]=1;
		  }
	      }
	    else if(Tct[i][j]==13)//columella bottom layer
	      {
		if(Tmt[i][j]<4)
		  {
		    Pin2PrePat[i][j]=0.5;
		    Pin2PrePat[ii][j]=0.5;
		  }
	      }
	    else if(Tct[i][j]>13)//>12)//columella
	      {
		Pin2PrePat[i][j]=1;
		Pin2PrePat[ii][j]=1;
	      }
	   
	  }
#endif
      }
#endif

#ifdef APOLAR
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(Tc[i][j]==2)//membrane
	  {
	    PinPrePat[i][j]=1;
	  }
      }  
#endif


  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
#ifdef AUX1INEPI
	if((Tct[i][j]!=6 && Tct[i][j]!=7) && (Tct[i][j]!=12 && Tct[i][j]!=18))
	  {
			Aux1PrePat[i][j]=1;
		//if((Tct[i][j]==8 || Tct[i][j]==9 || Tct[i][j]==10 || Tct[i][j]==11) && j<yMZEZ)
			//Aux1PrePat[i][j]=2;
		
	   if((Tct[i][j]==5  && j<yMZEZ) || Tct[i][j] == 2 || Tct[i][j] ==3 || Tct[i][j] ==4)//((Tct[i][j]==5 ||Tct[i][j]==6) && j<yMZEZ)
	      Aux1PrePat[i][j]=0.3;//0.8;
	   else if(Tct[i][j]>12 && Tct[i][j]!=13)
		  Aux1PrePat[i][j]=3;
#ifdef AUX1LRCextra
		else if(Tct[i][j]==1) // || ((Tct[i][j]==8 || Tct[i][j]==9 || Tct[i][j]==10 || Tct[i][j]==11) && j<yMZEZ-6*HMZ))
			Aux1PrePat[i][j]=3;
			
#endif
	  }
	else
#endif
	  Aux1PrePat[i][j]=0;
      }


for(i=0;i<n;i++)
	for(j=0;j<m;j++)
	{
		if(Tct[i][j]>7 && Tct[i][j]!=12)
			Lax3PrePat[i][j]=1;
		else
			Lax3PrePat[i][j]=0;
	}

  //check symmetry initial PIN layout
  /*
  for(j=0;j<m;j++)
    for(i=0;i<=xm;i++)
      {
	if((int)(1000*PinPrePat[i][j])!=(int)(1000*PinPrePat[n-1-i][j]))
	  {
	    printf("something is wrong in PIN layout at %i %i and %i %i\n",i,j,n-1-i,j);
	  }
      }
  printf("finished checking initial PIN layout\n");
  exit(1);*/

  //check symmetry initial AUX1 layout
  /*for(j=0;j<m;j++)
    for(i=0;i<=xm;i++)
      {
	if((int)(1000*Aux1PrePat[i][j])!=(int)(1000*Aux1PrePat[n-1-i][j]))
	  {
	    printf("something is wrong in AUX1 layout at %i %i and %i %i\n",i,j,n-1-i,j);
	  }
      }
  printf("finished checking initial AUX1 layout\n");
  exit(1);*/
}

void InitConditions()
{
  int i,j,k,q;
  Plasmodesmatapatterning();

  //set gene expression levels:
  for(q=0;q<actcells;q++)
    {
      MeanCells[q]=100;
      ARF[q]=0;//
      AA[q]=0;
      BB[q]=0;
      CC[q]=0;
      DD[q]=0;
      Plt[q]=10;
      Plts[q]=0;//10;
      ARR1[q]=0;
      ARR12[q]=0; 
      RGA[q]=0;
      Gibberellin[q]=0;
      PP[q]=0;
      
      if(CellMaxJ[q]<yLRC1){
        if (Tct[(CellMaxI[q]+CellMinI[q])/2][(CellMaxJ[q]+CellMinJ[q])/2]==12){
          Plts[q]=400;
          ARF[q]=90;//
          AA[q]=85;
          BB[q]=85;
          CC[q]=85;
          DD[q]=85;
	       Gibberellin[q] =maxGib/decayGib;
        }
	     else if(CellMaxJ[q]<yLRCstraight+10 && CellMinJ[q] > yQC-20){
	   divTF[q]=100;
	       Plts[q]=350;
          ARF[q]=50;//
          AA[q]=60;
          BB[q]=60;
          CC[q]=60;
          DD[q]=60;
	       Gibberellin[q] =(maxGib/decayGib)/2;
	     }
        else if (CellMaxJ[q]<(yMZEZ-yLRCstraight)/2+yLRCstraight){// rest of first half of meristem
        	   divTF[q]=80;
	       Plts[q]=80;
          ARF[q]=60;//
          AA[q]=40;
          BB[q]=40;
          CC[q]=40;
          DD[q]=30;
        }
	     else{ //final part of meristem
          if(   (Tct[(CellMaxI[q]+CellMinI[q])/2][(CellMaxJ[q]+CellMinJ[q])/2]==5) || ( (Tct[(CellMaxI[q]+CellMinI[q])/2][(CellMaxJ[q]+CellMinJ[q])/2]>=9) && (Tct[(CellMaxI[q]+CellMinI[q])/2][(CellMaxJ[q]+CellMinJ[q])/2]<=11) )   ){
	       Plts[q]=40;
            divTF[q]= 50;
          ARF[q]=60;//
          AA[q]=30;
          BB[q]=30;
          CC[q]=30;
          DD[q]=20;
	       Gibberellin[q]=(maxGib/decayGib)/5;
          }
          else{
            AA[q]=20;
            BB[q]=20;
            CC[q]=20;
            DD[q]=10;
           	Plts[q]=50;
            divTF[q]= 50;
          }
	     }
      }
      else if (CellMaxJ[q] < yMZEZ+6*HEZ+15){
        ARR1[q] = 50;
        RGA[q] = 50;
        GA3Ox2[q] = 50;
      }
      else if (CellMaxJ[q] < yMZEZ+6*HEZ+15*HDZ+22){
        ARR1[q] = 30;
        RGA[q] = 60;
        GA3Ox2[q] = 30;
	   } 
      

      Pin[q]=100;
      Pin2[q]=100;
      Yuc3[q]=50;//100;
      Gh317[q]=0;//100;
      Aux1[q]=30;//100;
#ifdef LAX3PREPATTERN
      Lax3[q]=30;
#else
      Lax3[q]=0;
#endif	  
      TimePrevGrowth[q]=0;
      //PrimeDiff[q]=0;
      Diff[q]=0;
      CellZonationState[q]=0;
    }
  
  

	  
  //set auxin concentration levels:
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(Tc[i][j]!=3 && Cell[i][j]!=-1)
	   {
	     //Caux1[i][j]=0.1;
	     if(j<10)
	       Caux1[i][j]=3500+(yEND-TOPJCELLS)*20;//4500;
	     else if(j<30)
	       Caux1[i][j]=1700+(yEND-TOPJCELLS)*10;//2000;
	     else if(j<60)
	      Caux1[i][j]=900;
	     else if(j<100)
	      Caux1[i][j]=400;
	     else if(j<250)
	      Caux1[i][j]=60;
	     else if(j<500)
	       Caux1[i][j]=20;
	     else
	       Caux1[i][j]=0.5;//0.1
	    
	  }
	//else if(Tc[i][j]==0)
	//Caux1[i][j]=0.1;
      }
}


